#include <gtk/gtk.h>
#include <gconf/gconf-client.h>
#include <libgircclient/girc-client.h>

#define LEMMING_NICK_KEY	"/apps/tinylemming/nick"
#define LEMMING_REAL_KEY	"/apps/tinylemming/real_name"
#define LEMMING_SERVER_KEY	"/apps/tinylemming/server"
#define LEMMING_PORT_KEY	"/apps/tinylemming/port"
#define LEMMING_CHANNEL_KEY	"/apps/tinylemming/channel"
#define LEMMING_LOCK_PREFS	"/apps/tinylemming/lockprefs"

typedef struct {
	GtkWidget	*main;
	GtkWidget	*text;
	GtkTextBuffer	*buffer;
	GtkWidget	*entry;
	GtkWidget	*userlist;
	GIrcClient	*client;
	GIrcTarget	*target;
	gchar		*nick;
	gchar		*real_name;
	gchar		*server;
	gint		port;
	gchar		*channel;
} TinyLemming;

typedef enum {
	NICK_PLAIN,
	NICK_BRACES,
	NICK_ACTION,
	NICK_NOTICE,
	NICK_QUERY,
	NICK_OWN_PLAIN,
	NICK_OWN_BRACES,
	NICK_OWN_ACTION
} NickMode;

typedef enum {
	LEMMING_PREF_OK,
	LEMMING_ERROR_NICK,
	LEMMING_ERROR_REAL,
	LEMMING_ERROR_SERVER,
	LEMMING_ERROR_PORT,
	LEMMING_ERROR_CHANNEL
} LemmingPrefError;

TinyLemming * lemming_new ( void );
void lemming_print (TinyLemming *, gchar *);
void lemming_nick_print (TinyLemming *, gchar *, NickMode);
void lemming_action_print (TinyLemming *, gchar *);
void lemming_notice_print (TinyLemming *, gchar *);
void lemming_scroll_end (TinyLemming *);
void lemming_command_handler (TinyLemming *, const gchar *);
TinyLemming * lemming_prefs_dialog (void);
void lemming_prefs_apply (GtkWidget *, gpointer);
void lemming_prefs_cancel (GtkWidget *, gpointer);
void lemming_prefs_load (GConfClient *);
void lemming_prefs_save (GConfClient *, TinyLemming *);
TinyLemming * lemming_prefs_validate ( TinyLemming * );
